"use client";

import * as React from "react";
import {
  ColumnDef,
  ColumnFiltersState,
  PaginationState,
  SortingState,
  VisibilityState,
  flexRender,
  getCoreRowModel,
  getFilteredRowModel,
  getPaginationRowModel,
  getSortedRowModel,
  useReactTable,
} from "@tanstack/react-table";
import { Button } from "@/components/ui/button";

import {
  Table,
  TableBody,
  TableCell,
  TableHead,
  TableHeader,
  TableRow,
} from "@/components/ui/table";
import { UserIcon } from "lucide-react";
import { cn } from "@/lib/utils";
import {
  DropdownMenu,
  DropdownMenuContent,
  DropdownMenuItem,
  DropdownMenuRadioGroup,
  DropdownMenuRadioItem,
  DropdownMenuTrigger,
} from "@/components/ui/dropdown-menu";
import { Input } from "@/components/ui/input";
import { InputGroup, InputGroupText } from "@/components/ui/input-group";
import { paginationBlog } from "@/service/blog/blog";
import { ticketingPagination } from "@/service/ticketing/ticketing";
import { Badge } from "@/components/ui/badge";
import { useRouter, useSearchParams } from "next/navigation";
import TablePagination from "@/components/table/table-pagination";
import columns from "./column";
import { getPlanningPagination } from "@/service/agenda-setting/agenda-setting";
import {
  Popover,
  PopoverContent,
  PopoverTrigger,
} from "@/components/ui/popover";
import { listDataMedia } from "@/service/broadcast/broadcast";
import { listEnableCategory } from "@/service/content/content";
import { Checkbox } from "@/components/ui/checkbox";
import { close, loading } from "@/config/swal";
import { Link } from "@/i18n/routing";

const dummyData = [
  {
    id: 1,
    name: "Prof. Dr. Ravi",
    region: "Nasional",
    skills: "Komunikasi",
    experience: "Akademisi",
  },
  {
    id: 2,
    name: "Prof. Dr. Novan",
    region: "DKI Jakarta",
    skills: "Hukum",
    experience: "Akademisi + Praktisi",
  },
];

const AddExpertTable = () => {
  const router = useRouter();
  const searchParams = useSearchParams();
  const [showData, setShowData] = React.useState("10");
  const [categories, setCategories] = React.useState<any>();
  const [dataTable, setDataTable] = React.useState<any[]>([]);
  const [totalData, setTotalData] = React.useState<number>(1);
  const [sorting, setSorting] = React.useState<SortingState>([]);
  const [columnFilters, setColumnFilters] = React.useState<ColumnFiltersState>(
    []
  );
  const [columnVisibility, setColumnVisibility] =
    React.useState<VisibilityState>({});
  const [rowSelection, setRowSelection] = React.useState({});
  const [pagination, setPagination] = React.useState<PaginationState>({
    pageIndex: 0,
    pageSize: Number(showData),
  });
  const [categoryFilter, setCategoryFilter] = React.useState<number[]>([]);
  const [statusFilter, setStatusFilter] = React.useState<number[]>([]);
  const [page, setPage] = React.useState(1);
  const [totalPage, setTotalPage] = React.useState(1);
  const table = useReactTable({
    data: dataTable,
    columns,
    onSortingChange: setSorting,
    onColumnFiltersChange: setColumnFilters,
    getCoreRowModel: getCoreRowModel(),
    getPaginationRowModel: getPaginationRowModel(),
    getSortedRowModel: getSortedRowModel(),
    getFilteredRowModel: getFilteredRowModel(),
    onColumnVisibilityChange: setColumnVisibility,
    onRowSelectionChange: setRowSelection,
    onPaginationChange: setPagination,
    state: {
      sorting,
      columnFilters,
      columnVisibility,
      rowSelection,
      pagination,
    },
  });

  let typingTimer: any;
  const doneTypingInterval = 1500;

  const handleKeyUp = () => {
    clearTimeout(typingTimer);
    typingTimer = setTimeout(doneTyping, doneTypingInterval);
  };

  const handleKeyDown = () => {
    clearTimeout(typingTimer);
  };

  async function doneTyping() {
    fetchData();
  }

  React.useEffect(() => {
    const pageFromUrl = searchParams?.get("page");
    if (pageFromUrl) {
      setPage(Number(pageFromUrl));
    }
  }, [searchParams]);

  React.useEffect(() => {
    fetchData();
    setPagination({
      pageIndex: 0,
      pageSize: Number(showData),
    });
  }, [page, showData]);

  async function fetchData() {
    try {
      loading();

      const contentData = dummyData;
      contentData.forEach((item: any, index: number) => {
        item.no = (page - 1) * Number(showData) + index + 1;
      });

      setDataTable(contentData);
      setTotalData(contentData?.length);
      setTotalPage(1);
      close();
    } catch (error) {
      console.error("Error fetching tasks:", error);
    }
  }

  React.useEffect(() => {
    getCategories();
  }, []);

  async function getCategories() {
    const category = await listEnableCategory("");
    const resCategory = category?.data?.data?.content;
    setCategories(resCategory);
  }

  return (
    <div className="w-full overflow-x-auto bg-white p-4 rounded-sm space-y-3">
      <div className="flex justify-between mb-10 items-center">
        <p className="text-xl font-medium text-default-900">Tenaga Ahli</p>
        <Link href="/admin/add-experts/create">
          <Button color="primary" size="md" className="text-sm">
            <UserIcon />
            Tambah Tenaga Ahli
          </Button>
        </Link>
      </div>

      <div className="flex justify-between ">
        <Input
          type="text"
          placeholder="Search"
          onKeyUp={handleKeyUp}
          onKeyDown={handleKeyDown}
          className="max-w-[300px]"
        />
        <div className="flex flex-row gap-2">
          <DropdownMenu>
            <DropdownMenuTrigger asChild>
              <Button size="md" variant="outline">
                1 - {showData} Data
              </Button>
            </DropdownMenuTrigger>
            <DropdownMenuContent className="w-56">
              <DropdownMenuRadioGroup
                value={showData}
                onValueChange={setShowData}
              >
                <DropdownMenuRadioItem value="10">
                  1 - 10 Data
                </DropdownMenuRadioItem>
                <DropdownMenuRadioItem value="20">
                  1 - 20 Data
                </DropdownMenuRadioItem>
                <DropdownMenuRadioItem value="25">
                  1 - 25 Data
                </DropdownMenuRadioItem>
                <DropdownMenuRadioItem value="50">
                  1 - 50 Data
                </DropdownMenuRadioItem>
              </DropdownMenuRadioGroup>
            </DropdownMenuContent>
          </DropdownMenu>
        </div>
      </div>
      <Table className="overflow-hidden">
        <TableHeader>
          {table.getHeaderGroups().map((headerGroup) => (
            <TableRow key={headerGroup.id} className="bg-default-200">
              {headerGroup.headers.map((header) => (
                <TableHead key={header.id}>
                  {header.isPlaceholder
                    ? null
                    : flexRender(
                        header.column.columnDef.header,
                        header.getContext()
                      )}
                </TableHead>
              ))}
            </TableRow>
          ))}
        </TableHeader>
        <TableBody>
          {table.getRowModel().rows?.length ? (
            table.getRowModel().rows.map((row) => (
              <TableRow
                key={row.id}
                data-state={row.getIsSelected() && "selected"}
                className="h-[75px]"
              >
                {row.getVisibleCells().map((cell) => (
                  <TableCell key={cell.id}>
                    {flexRender(cell.column.columnDef.cell, cell.getContext())}
                  </TableCell>
                ))}
              </TableRow>
            ))
          ) : (
            <TableRow>
              <TableCell colSpan={columns.length} className="h-24 text-center">
                No results.
              </TableCell>
            </TableRow>
          )}
        </TableBody>
      </Table>
      <TablePagination
        table={table}
        totalData={totalData}
        totalPage={totalPage}
      />
    </div>
  );
};

export default AddExpertTable;
